;----------------------------------------------------------------------------
;    MODULE NAME:   DEFINEIT.X
;
;        $Author:   Dennis_Bareis  $
;      $Revision:   1.1  $
;          $Date:   31 Jan 1999 17:40:50  $
;       $Logfile:   E:/DB/PVCS.IT/OS2/REXXHDR/DEFINEIT.X_V  $
;         SOURCE:   http://www.labyrinth.net.au/~dbareis/index.htm (db0@anz.com)
;
;    DESCRIPTION:   Example program for "DEFINEIT.XH".
;
;                   Compile with "ppwizard DEFINEIT.X /rexx"
;----------------------------------------------------------------------------

/*
 * $Header:   E:/DB/PVCS.IT/OS2/REXXHDR/DEFINEIT.X_V   1.1   31 Jan 1999 17:40:50   Dennis_Bareis  $
 */

/*--- Include the support code ----------------------------------------------*/
#include "ReplStr.XH"
#define  DEFINEIT_ABORT_ROUTINE  Abort      ;;Comment out line to try return code method (slower)
#include "DefineIt.XH"

/*--- Define some definitions (normally come from file "#define" etc) -------*/
call DefineItAddDefinition "AAAA",    "{The 1st Value}"
call DefineItAddDefinition "HasParm", "{$P1=^P1Default ^}{$P2}{$P3}"     ;;3 Parameters (first has default) - Notice first char defines the quote character
call DefineItAddDefinition "ZZZZ",    "{The last Value}"

/*--- Try some replacements -------------------------------------------------*/
call Test("123456789");
call Test("<" || "$AAAA>");
call Test("[[[<" || "$HASPARM P1=/parm1 / P2='Parm2' P3=* Parm3*>]]]");  ;;Tried 3 different "quote" characters
call Test("<" || "$HASPARM P2='Parm2' P3=* Parm3*>");
call Test("<" || "$NotKnown>");
exit(0);



/*===========================================================================*/
Test:
/*===========================================================================*/
   /*--- Show before --------------------------------------------------------*/
   Before = arg(1);
   say '';
   say 'BEFORE: "' || Before || '"'

   /*--- Perform replacement ------------------------------------------------*/
   After = ReplaceAllHashDefinedVariables(Before);

   /*--- Perform error checking if required (display AFTER) -----------------*/
   #ifdef DEFINEIT_ABORT_ROUTINE
          /*--- No need for error handler as code only gets here if alls OK ---*/
          say 'AFTER : "' || After || '"'
   #elseif
          /*--- No abort routine registered, check for error ----------------*/
          if  <$DEFINEIT_RC_VARIABLE> = 0 then
              say 'AFTER : "' || After || '"'
          else
          do
              say 'FAILED'
              say '~~~~~~'
              say 'Rc    : ' || <$DEFINEIT_RC_VARIABLE>;
              say 'Reason: ' || <$DEFINEIT_RC_VARIABLE>_TEXT;
          end;
   #endif
   return;



/*===========================================================================*/
Abort:
/*===========================================================================*/
   say ''
   say 'ABORT()'
   say '~~~~~~~'
   say arg(1);
   exit(255);
